<?php
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.menu');

class plgEmeraldFuturePay extends JPlugin
{

	var $_db = null;

	function plgEmeraldFuturePay(& $subject, $config)
	{
		$this->_db = JFactory::getDBO();
		parent::__construct($subject, $config);
	}

	function onReceivePayment(&$post)
	{
		if($post['processor'] != 'futurepay') return 0;
		
		//error_log("Receive POST: ".print_r($post, true), 3, JPATH_ROOT."/logs/fplog.log");
		
		if(!empty($post['params']))
		{
			$params = new JRegistry($post['params']);
		}
		else
		{
			$params = $this->params;
		}
		
		$user = JFactory::getUser($post['MC_userid']);
		
		$out['sid'] = $post['cartId'];
		$out['gateway'] = 'WorldPay';
		$out['price'] = $post['amount'];
		$out['pay'] = 'fail';
		$out['user_id'] = $post['MC_userid'];
		$out['pay'] = 'fail';
		$out['exit'] = 1;
		
		$out['gateway_id'] = $post['transId'];
		if($params->get('recurring'))
		{
			$out['gateway_id'] = $post['futurePayId'].'-'.$post['transId'];
		}
		
		if($post['transStatus'] == 'Y')
		{
			if($post['callbackPW'] != $params->get('password'))
			{
				//error_log("Verification failed: ".$params->get('password'), 3, JPATH_ROOT."/logs/fplog.log");
				echo 'Opc!! Back off!!';
				exit;
			}
			$out['pay'] = 'success';
			
			$futurepay_id = $out['gateway_id'];
			
			$db = & JFactory::getDBO();
			$query = "SELECT id FROM #__jcs_user_subscr WHERE gateway_id = '{$futurepay_id}'";
			$db->setQuery($query);
			if($db->loadResult())
			{
				//error_log("Double request", 3, JPATH_ROOT."/logs/fplog.log");
				return;
			}
			
			if(substr($post['wafMerchMessage'], 0, 4) == 'waf.')
			{
				$out['pay'] = 'fail';
			}
		}
		
		//error_log("Return OUT: ".print_r($out, true), 3, JPATH_ROOT."/logs/fplog.log");
		
		return $out;
		//http://www.worldpay.com/support/kb/bg/htmlredirect/rhtml5904.html
	
	}

	function onSendPayment($post)
	{
		if($post['processor'] != 'futurepay') return false;
		
		$params = new JRegistry($post['params']);
		$default = $this->params;
		
		$Itemid = JRequest::getVar('Itemid');
		
		$param['instId'] = $params->get('params.installID', $this->params->get('installID'));
		$param['cartId'] = strval($post['order_id']);
		$param['amount'] = $post['order_amount'];
		$param['testMode'] = $params->get('params.testMode', $this->params->get('testMode'));
		$param['currency'] = $params->get('params.currency', $this->params->get('currency'));
		$param['name'] = JFactory::getUser($post['user_id'])->get('name');
		$param['email'] = JFactory::getUser($post['user_id'])->get('email');
		//$param[$params->get('params.hideContact', $this->params->get('contact', 'hideContact'))] = 1;
		$param['descr'] = strval($post['order_title']);
		
		$param['MC_userid'] = $post['user_id'];
		$param['MC_processor'] = 'futurepay';
		$param['MC_callback'] = JURI::base() . 'index.php?option=com_emerald&task=plans.create&processor=futurepay&order_id='.$post['order_id'];
		
		if($params->get('params.hideCurrency', $this->params->get('hideCurrency')))
		{
			$param['hideCurrency'] = 1;
		}
		
		if($params->get('params.recurring', $this->params->get('recurring')))
		{
			switch ($post['days_type'])
			{
				case "days":
					$multi = 1;
				break;
				case "weeks":
					$multi = 2;
				break;
				case "months":
					$multi = 3;
				break;
				case "years":
					$multi = 4;
				break;
			}
			$param['noOfPayments'] = $params->get('params.noOfPayments', $this->params->get('noOfPayments', 0));
			$param['futurePayType'] = "regular";
			$param['normalAmount'] = $post['order_amount'];
			$param['intervalMult'] = $post['days'];
			$param['intervalUnit'] = $multi;
			$param["startDelayMult"] =$post['days'];
			$param["startDelayUnit"] =$multi;
			$param['option'] = 0;
			
			
			/*
			<INPUT TYPE="HIDDEN" NAME=startDelayMult VALUE=3>
			<INPUT TYPE="HIDDEN" NAME=startDelayUnit VALUE=2>
			<INPUT TYPE="HIDDEN" NAME=initialAmount VALUE=10.00>
			*/
			
		}
		
		$url = 'https://secure.worldpay.com/wcc/purchase?' . $this->worldpayUrl($param);
		if($params->get('params.testMode', $this->params->get('testMode')) == 100)
		{
			$param['name'] = 'AUTHORISED';
			$url = 'https://secure-test.worldpay.com/wcc/purchase?' . $this->worldpayUrl($param);
		}
		
		
		header("location: $url");
	}

	function onAfterReceivePayment($params, $payment)
	{
		if($params['processor'] != 'futurepay') return false;

		JFactory::getApplication()->close();
	}

	function worldpayUrl($param)
	{
		foreach($param as $k => $v)
		{
			$out[] = "$k=".urlencode($v);
		}
		return implode('&', $out);
	}
}

?>